
class Train():

	def __init__(self, n, s, d):
		self.number = n
		self.start = s
		self.destination = d
		self.stations = []
		self.wagons = []

	def add_station(self, s):
		self.stations.append(s)

	def set_wagons(self, w):
		self.wagons = w

	# Die folgenden zwei Methoden beinhalten Funktionalitaeten, die erst in der 3. Vorlesung
	#	erlaeutert werden

	def __len__(self):
		return len(self.wagons)

	def __str__(self):
		return "Zug {num} von {start} nach {dest}\n\tueber {stat}\n\tmit {nw} Wagen [{wt}]".format(
			num=self.number,
			start=self.start,
			dest=self.destination,
			stat=', '.join(self.stations),
			nw=len(self),
			wt=', '.join(map(lambda w : w.__class__.__name__, self.wagons))
		)

class Wagon():

	def __init__(self, p):
		self.previous_wagon = p

class GoodsWagon(Wagon):
	SELF_POWERED = False

	def __init__(self, *args):
		super().__init__(*args)
		self.goods = []

	def add_good(self, g):
		self.goods.append(g)

class Locomotive(Wagon):
	SELF_POWERED = True


l = Locomotive(None)
gw1 = GoodsWagon(l)
gw1.add_good("Getreide")
gw2 = GoodsWagon(gw1)
gw2.add_good("Hafer")
gw2.add_good("Haferflocken")
gw3 = GoodsWagon(gw2)

t = Train("GW 12", "Luebeck", "Muenchen")
t.add_station("Hannover")
t.add_station("Kassel")
t.add_station("Regensburg")
t.set_wagons([l, gw1, gw2, gw3])

print("Zuglänge", len(t))
print(t)
print("Wagen 2 mit", gw2.goods)







