
class DictContainer():

	def __init__(self):
		self.dict = {}

	def __setitem__(self, key, value):
		self.dict[key] = value

	def __getitem__(self, key):
		return self.dict[key]
	
	def __delitem__(self, key):
		del self.dict[key]

	def __contains__(self, key):
		return key in self.dict

	def __str__(self):
		return str(self.dict)

dc = DictContainer()

dc["a"] = "A"
dc.__setitem__("b", "B") 
print(dc)

print(dc["a"])
print(dc.__getitem__("b"))

del dc["a"]
print(dc)

print("2" in dc, "b" in dc)