import re

m = re.match(r'^H(e|a)llo$', "Hello")
print(m.groups()) # ('e',)

m = re.search(r'H(e|a)llo', "Hallo Magnus, Hello Mr. Bender,")
print(m.groups()) # ('a',)

m = re.findall(r'H(e|a)llo', "Hallo Magnus, Hello Mr. Bender,")
print(m) # ['a', 'e']

m = re.findall(r'(H(e|a)llo)', "Hallo Magnus, Hello Mr. Bender,")
print(m) # [('Hallo', 'a'), ('Hello', 'e')]

m = re.findall(r'H(?:e|a)llo ([^,]+)', "Hallo Magnus, Hello Mr. Bender,")
print(m) # ['Magnus', 'Mr. Bender']

mail = re.compile(r'[^@]+@(?:[a-z]*\.)?uni-luebeck\.de')
print(mail.match("m.bender@uni-luebeck.de")) # <re.Match object; span=(0, 23), match='m.bender@uni-luebeck.de'>
print(mail.match("bender@ifis.uni-luebeck.de")) # <re.Match object; span=(0, 26), match='bender@ifis.uni-luebeck.de'>
print(mail.match("bender@FAKEuni-luebeck.de")) # None