
import numpy as np

def d_e_numpy(x, y):
	return np.sqrt(
		np.power(
			(x - y),
			2
		).sum()
	)

print(d_e_numpy(
	np.array([1, 2, 1]),
	np.array([1, 3, 2])
))


import math

def d_e_py(x, y):
	r = 0
	for x_i, y_i in zip(x, y):
		r += (x_i - y_i)**2
	return math.sqrt(r)

print(d_e_py(
	[1, 2, 1],
	[1, 3, 2]
))

import timeit

x = np.random.rand(1000000)
y = np.random.rand(1000000)

print(timeit.timeit('d_e_numpy(x, y)', number=50, globals=globals()))

x_list = x.tolist()
y_list = x.tolist()

print(timeit.timeit('d_e_py(x_list, y_list)', number=50, globals=globals()))

from scipy.spatial import distance

print(timeit.timeit('distance.euclidean(x, y)', number=50, globals=globals()))