# Diese Daten werden intern benoetigt, um die Services fuer verschiedene
# Sprachen anbieten zu koennen. Der Download muss einmal durchgefuehrt werden und 
# anschliessend liegen die Daten auf dem PC.
#import nltk
#nltk.download('punkt')
#nltk.download('stopwords')
#nltk.download('wordnet')
#nltk.download('omw-1.4')

import re
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize, sent_tokenize
from nltk.stem.snowball import SnowballStemmer

text = "Geben Sie den Link zu Ihrem Repository im Moodle ein. Dabei werden Sie auch gefragt, ob das Repository öffentlich oder verborgen ist! Denken Sie bei verborgen Repositories daran, dem GitHub-User WerkzeugeWissArbeiten Zugriffsrechte für Ihr erstelltes Git-Repository zu gewähren."

stop_words = set(stopwords.words("german"))
print(stop_words)

stemmer_de = SnowballStemmer("german")
stemmer_en = SnowballStemmer("english")

print(stemmer_de.stem("öffentlich"))
print(stemmer_de.stem("Öffentlichkeit"))

print(stemmer_en.stem("repository"))
print(stemmer_en.stem("repositories"))

text = text.replace("-", " ")
sentences = []
for sentence in sent_tokenize(text, language='german'):

	words = []
	for word in word_tokenize(sentence, language='german'):

		word = word.lower()
		word = re.sub("[^a-zäüöß]", "", word)

		if word not in stop_words:
			word = stemmer_de.stem(word)
			word = stemmer_en.stem(word)
			if len(word) > 0:
				words.append(word)

	sentences.append(words)

print(sentences)
