from sklearn.cluster import KMeans
import numpy as np
import matplotlib.pyplot as plt

X = np.array([
	[1, 1], [1, 2], [2, 2],
	[4, 1], [5, 1], [5, 2]
])

plt.scatter(X[:, 0], X[:, 1], s=20)
plt.show()

km = KMeans(n_clusters=2, init='random', tol=1e-4)
km.fit(X)

print(km.cluster_centers_)
print(km.labels_)

print(km.predict([[1, 1.5]]))

# Plot mit Label & Cluster
plt.scatter(X[:, 0], X[:, 1], s=20, c=km.labels_)
plt.scatter(km.cluster_centers_[:, 0], km.cluster_centers_[:, 1], s=20, marker="d")
plt.show()
