# partly taken from
# https://huggingface.co/docs/transformers/v4.25.1/en/model_doc/bert#transformers.BertForNextSentencePrediction

from transformers import BertTokenizer, BertForNextSentencePrediction
import torch

tokenizer = BertTokenizer.from_pretrained("bert-base-uncased")
model = BertForNextSentencePrediction.from_pretrained("bert-base-uncased")

prompt = "In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced."
next_sentence = "The sky is blue due to the shorter wavelength of blue light."
# next_sentence = "Thus, one might need a knive to cut the food."

encoding = tokenizer(prompt, next_sentence, return_tensors="pt")
print(list(encoding.keys()))

outputs = model(**encoding, labels=torch.LongTensor([1]))
print(outputs.logits)

print( "random sentence" if outputs.logits[0, 0] < outputs.logits[0, 1]  else "next sentence") 